diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
index 111a7145c..d66c6bc05 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkDecoratorNether.java
@@ -8,8 +8,8 @@ import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.ChunkDecorator;
 import net.minecraft.core.world.generate.feature.*;
+import net.minecraft.core.world.generate.feature.tree.WorldFeatureBoneshaleTree;
 import net.minecraft.core.world.noise.FractalNoise2D;
-import net.minecraft.core.world.noise.FractalNoise3D;
 import net.minecraft.core.world.noise.ImprovedPerlinNoise;
 import net.minecraft.core.world.noise.Noise2D;
 import net.minecraft.core.world.pos.TilePos;
@@ -45,68 +45,123 @@ public class ChunkDecoratorNether
 
         final @NotNull TilePos ti = new TilePos();
 
-        if (biome == Biomes.NETHER_CRYSTAL_FOREST) {
+        if (biome == Biomes.NETHER_CRYSTAL_FOREST || biome == Biomes.NETHER_CRYSTAL_FIELD ) {
             double noiseScale = 0.5;
 
-            int density = (int) ((this.crystalDensityNoise.getValue(x * noiseScale, z * noiseScale) - 6D + 36D) / 6D);
+            int density = (int) ((this.crystalDensityNoise.getValue(x * noiseScale, z * noiseScale) - 6D + 30D) / 6D);
 
-            for (int i = 0; i < density - 5; i++) {
-                int xf = x + rand.nextInt(16) + 8;
-                int yf = this.world.getWorldType().getOceanY() + rand.nextInt(5);
-                int zf = z + rand.nextInt(16) + 8;
-                boolean isCeiling = rand.nextInt(5) == 0;
-                new WorldFeatureCrystalChunk(isCeiling).place(this.world, rand, xf, yf, zf);
+            if (biome == Biomes.NETHER_CRYSTAL_FOREST) {
+                for (int i = 0; i < density + 4; i++) {
+                    ti.set(
+                            x + rand.nextInt(16) + 8,
+                            rangeY / 2 + rand.nextInt(rangeY - 8) + 4,
+                            z + rand.nextInt(16) + 8
+                    );
+
+                    boolean isCeiling = rand.nextInt(5) == 0;
+                    new WorldFeatureRubyglassCrystal(isCeiling).place(this.world, rand, ti);
+                }
+
+
+                for (int i = 0; i < density + 6; i++) {
+                    ti.set(
+                            x + rand.nextInt(16) + 8,
+                            rangeY / 2 + rand.nextInt(rangeY - 8) + 4,
+                            z + rand.nextInt(16) + 8
+                    );
+
+                    new WorldFeatureRubyglassCrystal(false, 25, 50).place(world, rand, ti);
+                }
             }
 
+            ti.set(
+                    x + rand.nextInt(16) + 8,
+                    rangeY / 2 + rand.nextInt(rangeY - 8) + 4,
+                    z + rand.nextInt(16) + 8
+            );
+
+            new WorldFeatureRubyglassCrystal(false, 20, 30).place(world, rand, ti);
+
 
-            for (int i = 0; i < density - 5; i++) {
+            for (int i = 0; i < 20; i++) {
                 int xf = x + rand.nextInt(16) + 8;
                 int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
                 int zf = z + rand.nextInt(16) + 8;
-                new WorldFeatureCrystalChunk(false, 15, 30, true).place(this.world, rand, xf, yf, zf);
-
+                (new WorldFeatureRubyglassGrowthPatch()).place(world, rand, xf, yf, zf);
             }
 
-            for (int i = 0; i < 40; i++) {
+            for(int l18 = 0; l18 < 30; l18++)
+            {
+                int l21 = x + rand.nextInt(16) + 8;
+                int k23 = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
+                int l24 = z + rand.nextInt(16) + 8;
+                (new WorldFeatureNetherLava(Blocks.FLUID_WATER_FLOWING.id())).place(world, rand, l21, k23, l24);
+            }
+            if (rand.nextInt(4) == 0) {
                 int xf = x + rand.nextInt(16) + 8;
-                int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int yf = rangeY / 2 + rand.nextInt(rangeY - 8) + 4;
                 int zf = z + rand.nextInt(16) + 8;
-                (new WorldFeatureDeadBush(Blocks.CRYSTAL_STALK.id())).place(this.world, rand, xf, yf, zf);
+                new WorldFeaturePillar(Blocks.NETHERRACK.id(), true).place(world, rand, xf, yf, zf);
             }
+        }
 
-            for (int l18 = 0; l18 < 50; l18++) {
+        if (biome == Biomes.NETHER_VOLCANIC_ISLANDS) {
+            for(int l18 = 0; l18 < 50; l18++)
+            {
                 int l21 = x + rand.nextInt(16) + 8;
                 int k23 = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
                 int l24 = z + rand.nextInt(16) + 8;
-                (new WorldFeatureLiquid(Blocks.FLUID_WATER_FLOWING.id())).place(this.world, rand, l21, k23, l24);
+                (new WorldFeatureNetherLava(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, l21, k23, l24);
             }
 
-        }
-//
-//        if (biome == Biomes.NETHER_SULFUR_POOLS) {
-//            for (int i = 0; i < 2; i++) {
-//                int xf = x + rand.nextInt(16) + 8;
-//                int yf = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
-//                int zf = z + rand.nextInt(16) + 8;
-//                new WorldFeaturePillar(Blocks.COBBLE_NETHERRACK.id, true).place(world, rand, xf, yf, zf);
-//            }
-//        }
-
-        if (biome == Biomes.NETHER_ASH_PLAINS) {
-            if (rand.nextInt(2) == 0) {
+            if (rand.nextInt(4) == 0) {
                 int xf = x + rand.nextInt(16) + 8;
-                int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int yf = rangeY / 2 + rand.nextInt(rangeY - 8) + 4;
                 int zf = z + rand.nextInt(16) + 8;
-                new WorldFeaturePillar(Blocks.SLATE.id(), false).place(this.world, rand, xf, yf, zf);
+                new WorldFeaturePillar(Blocks.COBBLE_BASALT.id(), true).place(world, rand, xf, yf, zf);
+            }
+
+            for (int i = 0; i < 2; i++) {
+                int xf1 = x + rand.nextInt(16) + 8;
+                int yf1 = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf1 = z + rand.nextInt(16) + 8;
+                new WorldFeatureMagmaBoulder().place(world, rand, xf1, yf1, zf1);
             }
+
         }
 
-        if (biome != Biomes.NETHER_ASH_PLAINS && biome != Biomes.NETHER_BONEYARD) {
-            for (int i = 0; i < 8; i++) {
+        if (biome == Biomes.NETHER_SULFUR_POOLS) {
+            if (rand.nextInt(8) != 0) {
+                new WorldFeatureTerrace(Blocks.FLUID_WATER_STILL, Blocks.BRIMSAND).place(world, rand, x, 0, z);
+            }
+
+            if (rand.nextInt(8) == 0) {
                 int xf = x + rand.nextInt(16) + 8;
                 int yf = rangeY / 2 + rand.nextInt(rangeY - 8) + 4;
                 int zf = z + rand.nextInt(16) + 8;
-                (new WorldFeatureNetherLava(Blocks.FLUID_LAVA_FLOWING.id())).place(this.world, rand, xf, yf, zf);
+                new WorldFeaturePillar(Blocks.COBBLE_BASALT.id(), true).place(world, rand, xf, yf, zf);
+            }
+
+            for(int l18 = 0; l18 < 30; l18++)
+            {
+                int l21 = x + rand.nextInt(16) + 8;
+                int k23 = minY + rand.nextInt(rand.nextInt(rangeY - (rangeY / 16)) + (rangeY / 16));
+                int l24 = z + rand.nextInt(16) + 8;
+                (new WorldFeatureNetherLava(Blocks.FLUID_LAVA_FLOWING.id())).place(world, rand, l21, k23, l24);
+            }
+
+            for (int i = 0; i < 1; i++) {
+                int xf1 = x + rand.nextInt(16) + 8;
+                int yf1 = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf1 = z + rand.nextInt(16) + 8;
+                new WorldFeatureThermalSpire().place(world, rand, xf1, yf1, zf1);
+            }
+
+            for (int i = 0; i < 2; i++) {
+                int xf1 = x + rand.nextInt(16) + 8;
+                int yf1 = world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf1 = z + rand.nextInt(16) + 8;
+                new WorldFeatureMagmaBoulder().place(world, rand, xf1, yf1, zf1);
             }
         }
 
@@ -118,27 +173,6 @@ public class ChunkDecoratorNether
         }
 
         int max;
-        if (biome != Biomes.NETHER_ASH_PLAINS && biome != Biomes.NETHER_BONEYARD) {
-            max = rand.nextInt(rand.nextInt(10) + 1);
-            for (int i = 0; i < max; i++) {
-                int xf = x + rand.nextInt(16) + 8;
-                int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
-                int zf = z + rand.nextInt(16) + 8;
-                (new WorldFeatureFire()).place(this.world, rand, xf, yf, zf);
-            }
-        }
-
-        if (biome == Biomes.NETHER_BONEYARD) {
-            max = rand.nextInt(20) + 5;
-            for (int i = 0; i < max; i++) {
-                ti.set(
-                    x + rand.nextInt(16) + 8,
-                    this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4,
-                    z + rand.nextInt(16) + 8
-                );
-                (new WorldFeatureColdFire()).place(this.world, rand, ti);
-            }
-        }
 
         max = rand.nextInt(rand.nextInt(10) + 1);
         for (int i = 0; i < max; i++) {
@@ -155,19 +189,72 @@ public class ChunkDecoratorNether
             new WorldFeatureGlowstoneB().place(this.world, rand, xf, yf, zf);
         }
 
-        if (biome != Biomes.NETHER_ASH_PLAINS && biome != Biomes.NETHER_BONEYARD) {
-            if (rand.nextInt(8) == 0) {
-                int xf = x + rand.nextInt(16) + 8;
-                int yf = rangeY / 2 + rand.nextInt(rangeY - 16) + 8;
-                int zf = z + rand.nextInt(16) + 8;
-                (new WorldFeatureLake(Blocks.FLUID_LAVA_STILL.id())).place(this.world, rand, xf, yf, zf);
-            }
 
-            for (int i = 0; i < /*20*/80; i++) {
+        if (biome == Biomes.NETHER_VOLCANIC_ISLANDS) {
+            for (int i = 0; i < 20; i++) {
                 int xf = x + rand.nextInt(16);
-                int yf = rangeY / 2 + rand.nextInt(rangeY);
+                int yf = rangeY / 2 + rand.nextInt(rangeY - 8) + 4;
                 int zf = z + rand.nextInt(16);
-                (new WorldFeaturePumice(32)).place(this.world, rand, xf, yf, zf);
+                new WorldFeatureOre(Blocks.ORE_NETHERCOAL_NETHERRACK.id(), 16).place(this.world, rand, xf, yf, zf);
+            }
+        }
+
+        max = 4;
+
+        if(biome == Biomes.NETHER_VOLCANIC_ISLANDS || biome == Biomes.NETHER_SULFUR_POOLS) {
+            max = 8;
+        }
+        if(biome == Biomes.NETHER_CRYSTAL_FIELD || biome == Biomes.NETHER_CRYSTAL_FOREST) {
+            max = 0;
+        }
+
+        for(int i = 0; i < max; i++)
+        {
+            int xf = x + rand.nextInt(16) + 8;
+            int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+            int zf = z + rand.nextInt(16) + 8;
+            (new WorldFeatureFire()).place(this.world, rand, xf, yf, zf);
+        }
+
+        max = 2;
+
+        if(biome == Biomes.NETHER_OLD_WORLD) {
+            max = 8;
+        }
+
+        for(int i = 0; i < max; i++)
+        {
+            int xf = x + rand.nextInt(16) + 8;
+            int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+            int zf = z + rand.nextInt(16) + 8;
+            (new WorldFeatureNetherPatch(Blocks.BONE_PILE.id())).place(this.world, rand, xf, yf, zf);
+        }
+
+        max = 4;
+
+        if(biome == Biomes.NETHER_OLD_WORLD) {
+            max = 2;
+        }
+
+        for(int i = 0; i < max; i++)
+        {
+            int xf = x + rand.nextInt(16) + 8;
+            int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+            int zf = z + rand.nextInt(16) + 8;
+            (new WorldFeatureNetherPatch(Blocks.SOULCATCHER.id())).place(this.world, rand, xf, yf, zf);
+        }
+
+        if(biome == Biomes.NETHER_OLD_WORLD) {
+            double noiseScale = 0.5;
+
+            int density = (int) ((this.crystalDensityNoise.getValue(x * noiseScale, z * noiseScale) - 6D + 20D) / 6D);
+
+            for(int i = 0; i < density + 4; i++)
+            {
+                int xf = x + rand.nextInt(16) + 8;
+                int yf = this.world.getWorldType().getOceanY() + rand.nextInt(rangeY - 8) + 4;
+                int zf = z + rand.nextInt(16) + 8;
+                (new WorldFeatureBoneshaleTree(0, Blocks.BONESHALE.id())).place(this.world, rand, xf, yf, zf);
             }
         }
 
@@ -182,8 +269,8 @@ public class ChunkDecoratorNether
                 dy++;
                 Biome localBiome = this.world.getBlockBiome(dx, dy, dz);
 
-                if ((localBiome == Biomes.NETHER_ASH_PLAINS || localBiome == Biomes.NETHER_BONEYARD) && dy > 0 && dy < this.world.getHeightBlocks()) {
-                    if (this.world.isAirBlock(dx, dy, dz) && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion() && this.world.getBlockId(dx, dy - 1, dz) != Blocks.OBSIDIAN.id()) {
+                if (localBiome != null && localBiome.hasSurfaceSnow() && (dy > 0 && dy < this.world.getHeightBlocks())) {
+                    if (this.world.isAirBlock(dx, dy, dz) && this.world.getBlockMaterial(dx, dy - 1, dz).blocksMotion()) {
                         this.world.setBlockWithNotify(dx, dy, dz, Blocks.LAYER_ASH.id());
                     }
                 }
@@ -191,7 +278,6 @@ public class ChunkDecoratorNether
 
         }
 
-
         BlockLogicSand.fallInstantly = false;
 
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
index 5f0a9c863..159e90c92 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/ChunkGeneratorNether.java
@@ -1,10 +1,7 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.generate.CavesLargeFeature;
-import net.minecraft.core.world.generate.LargeFeature;
-import net.minecraft.core.world.generate.NetherBonesLargeFeature;
-import net.minecraft.core.world.generate.WarrensCavesLargeFeature;
+import net.minecraft.core.world.generate.*;
 import net.minecraft.core.world.generate.chunk.perlin.ChunkGeneratorPerlin;
 import org.jetbrains.annotations.NotNull;
 
@@ -19,8 +16,8 @@ public class ChunkGeneratorNether
             new LargeFeature[]
                 {
                     new CavesLargeFeature(64, 256),
-                    new WarrensCavesLargeFeature(0, 128),
-                    new NetherBonesLargeFeature(64, 256)
+                    new LavaFloeLargeFeature(),
+                    new ShelfLargeFeature()
                 }
         );
     }
diff --git a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
index 5f991a5d2..adcdae007 100644
--- a/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
+++ b/game/core/src/main/java/net/minecraft/core/world/generate/chunk/perlin/nether/DensityGeneratorNether.java
@@ -1,24 +1,15 @@
 package net.minecraft.core.world.generate.chunk.perlin.nether;
 
-import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.biome.Biomes;
-import net.minecraft.core.world.biome.provider.BiomeProviderNether;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.generate.chunk.perlin.DensityGenerator;
 import net.minecraft.core.world.noise.*;
 import net.minecraft.core.world.type.WorldType;
 import org.jetbrains.annotations.NotNull;
 
-import java.util.HashMap;
-import java.util.Map;
-
 public class DensityGeneratorNether
     implements DensityGenerator {
-    private interface BiomeDensityGenerator {
-        double[] generateDensityMap(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z);
-    }
 
     public static class BiomeOverlapPair {
         public boolean hasOverlap;
@@ -43,8 +34,6 @@ public class DensityGeneratorNether
 
     private final @NotNull FractalNoise2D<?> islandNoise;
 
-    private final @NotNull Map<@NotNull Biome, @NotNull BiomeDensityGenerator> densityGeneratorMap = new HashMap<>();
-
     public DensityGeneratorNether(World world) {
         this.world = world;
 
@@ -60,13 +49,6 @@ public class DensityGeneratorNether
         this.ravineNoise2 = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 4, 6));
         this.poolNoiseOver = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 4, 10));
         this.poolNoiseUnder = new FractalNoise3D<>(SimplexNoise.genOctaves(seed, 1, 14));
-
-        this.densityGeneratorMap.put(Biomes.NETHER_NETHER, this::generateDensityMapBiomeNether);
-        this.densityGeneratorMap.put(Biomes.NETHER_VOLCANIC_ISLANDS, this::generateDensityMapBiomeNether);
-        this.densityGeneratorMap.put(Biomes.NETHER_SULFUR_POOLS, this::generateDensityMapBiomeNether);
-        this.densityGeneratorMap.put(Biomes.NETHER_CRYSTAL_FOREST, this::generateDensityMapBiomeNether);
-        this.densityGeneratorMap.put(Biomes.NETHER_ASH_PLAINS, this::generateDensityMapBiomeNether);
-        this.densityGeneratorMap.put(Biomes.NETHER_BONEYARD, this::generateDensityMapBiomeNether);
     }
 
     @Override
@@ -85,52 +67,13 @@ public class DensityGeneratorNether
         int threeQuarterYSize = ((int) (terrainHeight * 0.75f) / 8) + 1;
 
         double[] densityMapArray = new double[xSize * ySize * zSize];
-        Map<Biome, double[]> perBiomeDensityMaps = new HashMap<>();
-
-        BiomeOverlapPair[] overlapPairs = new BiomeOverlapPair[xSize * zSize];
-
-        // Cache density maps for biome(s)
-        int xSizeScale = 16 / xSize;
-        for (int dx = 0; dx < xSize; dx++) {
-            int ix = dx * xSizeScale + xSizeScale / 2;
-            for (int dz = 0; dz < zSize; dz++) {
-                int iz = dz * xSizeScale + xSizeScale / 2;
-                double temperature = chunk.temperature[ix * 16 + iz];
-                BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz] = new BiomeOverlapPair();
-                this.getOverlap(temperature, overlapPair);
-
-                if (!perBiomeDensityMaps.containsKey(overlapPair.biomeA)) {
-                    perBiomeDensityMaps.put(overlapPair.biomeA, this.densityGeneratorMap.get(overlapPair.biomeA).generateDensityMap(chunk, (int) (terrainHeight * 0.75f), xSize, threeQuarterYSize, zSize, x, y, z));
-                }
-                if (overlapPair.hasOverlap) {
-                    if (!perBiomeDensityMaps.containsKey(overlapPair.biomeB)) {
-                        perBiomeDensityMaps.put(overlapPair.biomeB, this.densityGeneratorMap.get(overlapPair.biomeB).generateDensityMap(chunk, (int) (terrainHeight * 0.75f), xSize, threeQuarterYSize, zSize, x, y, z));
-                    }
-                }
-            }
-        }
+        double[] biomeDensityMap = this.generateDensityMap(xSize, threeQuarterYSize, zSize, x, y, z);
 
-        // Merge density maps
         for (int dx = 0; dx < xSize; dx++) {
             for (int dz = 0; dz < zSize; dz++) {
-                BiomeOverlapPair overlapPair = overlapPairs[dx * xSize + dz];
-                double[] densityMapA = perBiomeDensityMaps.get(overlapPair.biomeA);
-                double[] densityMapB = null;
-                if (overlapPair.hasOverlap) {
-                    densityMapB = perBiomeDensityMaps.get(overlapPair.biomeB);
-                }
-
-                if (densityMapB != null) {
-                    for (int dy = 0; dy < threeQuarterYSize; dy++) {
-                        double densityA = densityMapA[(dx * zSize * threeQuarterYSize) + (dz * threeQuarterYSize) + dy];
-                        double densityB = densityMapB[(dx * zSize * threeQuarterYSize) + (dz * threeQuarterYSize) + dy];
-                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + quarterYSize - 1)] = MathHelper.lerp(densityA, densityB, overlapPair.biomeBPercentage);
-                    }
-                } else {
-                    for (int dy = 0; dy < threeQuarterYSize; dy++) {
-                        double densityA = densityMapA[(dx * zSize * threeQuarterYSize) + (dz * threeQuarterYSize) + dy];
-                        densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + quarterYSize - 1)] = densityA;
-                    }
+                for (int dy = 0; dy < threeQuarterYSize; dy++) {
+                    double density = biomeDensityMap[(dx * zSize * threeQuarterYSize) + (dz * threeQuarterYSize) + dy];
+                    densityMapArray[(dx * zSize * ySize) + (dz * ySize) + (dy + quarterYSize - 1)] = density;
                 }
             }
         }
@@ -138,7 +81,7 @@ public class DensityGeneratorNether
         return densityMapArray;
     }
 
-    private double[] generateDensityMapBiomeNether(Chunk chunk, int terrainHeight, int xSize, int ySize, int zSize, int x, int y, int z) {
+    private double[] generateDensityMap(int xSize, int ySize, int zSize, int x, int y, int z) {
         double[] densityMapArray = new double[xSize * ySize * zSize];
 
         final double mainNoiseScaleX = 80.0;
